var restart_tabbed_g = function () {

	var Cc = Components.classes;
	var Ci = Components.interfaces;

	var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
	var prefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch);
	var startup = Ci.nsIAppStartup;
	var home = "browser.startup.homepage";
	var old_home = "extension_buttons.old_home";
	var others = "extension_buttons.others";
	var lock = "extension_buttons.lock";
	var browser_window = "navigator:browser";

	var do_quit = function (flag) {
		prefs.setBoolPref(lock, false);
		Cc["@mozilla.org/toolkit/app-startup;1"].getService(startup).quit(startup.eAttemptQuit | (flag ? startup.eRestart : 0));
	};
		
	var do_restart = function () {
		do_quit(true);
	};

	var do_exit = function () {
		do_quit(false);
	};

	var collect_urls = function (win) {
		var url = "";
		var ntabs = win.gBrowser.mPanelContainer.childNodes.length;
		for (var i = 0; i < ntabs; ++i) {
			var b = win.gBrowser.getBrowserAtIndex(i);
			try {
				url += b.currentURI.spec + "|";
			} catch (e) {
				// ignore e
			}
		}
		url = url.replace(/\|$/, "");
		return url;
	};

	var collect_other_windows = function () {
		var enumvar = wm.getEnumerator(browser_window);
		var out = [];
		while (enumvar.hasMoreElements()) {
			var win = enumvar.getNext();
			if (win != window) {
				out.push(win);
			}
		}
		return out;
	};

	var x_escape = function (s) {
		return s.replace(/[>\\]/g, function (x) { return "\\" + (x == ">" ? "~" : x); });
	};

	var x_unescape = function (s) {
		return s.replace(/\\(.)/g, function (_, x) { return x == "~" ? ">" : x; });
	};

	var save_state = function () {
		prefs.setCharPref(others, collect_other_windows().map(function (w) { return ">" + x_escape(collect_urls(w)); }).join(""));

		var prev = prefs.getCharPref(home);
		var cur = collect_urls(window);
		prefs.setCharPref(home, cur == "" ? "about:blank" : cur);
		prefs.setCharPref(old_home, prev);
	};

	return {
		exec: function () {
			save_state();
			do_restart();
		},

		exit: function () {
			save_state();
			do_exit();
		},

		restore_state: function () {
			if (prefs.getBoolPref(lock)) {
				return;
			}
			prefs.setBoolPref(lock, true);

			var orig = prefs.getCharPref(old_home);
			prefs.setCharPref(home, orig);
			prefs.setCharPref(old_home, "");

			var saved = prefs.getCharPref(others);
			var chunks = saved.match(/>[^>]*/g);
			if (chunks.length != 0) {
				var wins = chunks.map(function (p) { return x_unescape(p.substr(1)).split("|"); });

				wins.forEach(
					function (w) {
						window.open();
						if (w.lenth != 0) {
							var tb = wm.getMostRecentWindow(browser_window).getBrowser();
							var first = w.shift();
							tb.loadURI(first);
							w.forEach(function (url) { tb.addTab(url); });
						}
					}
				);
			}
			prefs.setCharPref(others, "");
		}
	};
}();

addEventListener("load", restart_tabbed_g.restore_state, false);
